//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * Gԃwb_
 * @author Junpee
 */

#ifndef ENEMY_STATE_H_
#define ENEMY_STATE_H_

#include "Game/System/SystemReference.h"

class Stage;

//------------------------------------------------------------------------------
/**
 * G
 */
class EnemyState : public SystemReference{
friend class Enemy;
public:
	//--------------------------------------------------------------------------
	// Aj
	//--------------------------------------------------------------------------
	/**
	 * RXgN^
	 * @param enemy G
	 */
	EnemyState(Enemy* enemy);

	/**
	 * fXgN^
	 */
	virtual ~EnemyState();

protected:
	//--------------------------------------------------------------------------
	/**
	 * xƈʒǔvZ
	 * @param addVelocity ǉ鑬x
	 */
	virtual void calcVelocityAndPosition(Vector3 addVelocity = Vector3::zero);

	/**
	 * n`RW
	 */
	virtual void landCollide();

	/**
	 * URW
	 * @param bone {[
	 * @param offset RW̃ItZbg
	 * @param size RW̃TCY
	 * @param damage RW̃_[W
	 */
	virtual void attackCollide(
		Bone* bone, const Vector3& offset, float size, int damage);

	/**
	 * `ZbgAbv
	 * @param animationTime Aj[V
	 */
	virtual void drawSetup(	float animationTime);

	//--------------------------------------------------------------------------
	/**
	 * G̎擾
	 * @return G
	 */
	virtual Enemy* getEnemy(){ return enemy_; }

	/**
	 * sJE^̎擾
	 * @return sJE^
	 */
	virtual int getRunCounter() const{ return runCounter_; }

	/**
	 * vCƂ̊Ԋu
	 * @return vCƂ̊Ԋu
	 */
	virtual const Vector3& getPlayerDistance(){ return playerDistance_; }

	/**
	 * vC̎擾
	 * @return vC
	 */
	virtual Vector3 getPlayerDirection(){
		Vector3 playerDirection = getPlayerDistance();
		playerDirection.y = 0.f;
		if(!playerDirection.isZero()){ playerDirection.normalize(); }
		return playerDirection;
	}

	//--------------------------------------------------------------------------
	// s
	//--------------------------------------------------------------------------
	/**
	 * 
	 */
	virtual void initialize() = 0;

	/**
	 * n
	 */
	virtual void finalize() = 0;

	/**
	 * s
	 */
	virtual void run() = 0;

	/**
	 * s̎
	 */
	virtual void runImplement();

	//--------------------------------------------------------------------------
	// V[m[h
	//--------------------------------------------------------------------------
	/**
	 * V[m[h̎擾
	 * @return V[m[h
	 */
	virtual SceneNode* getSceneNode();

	//--------------------------------------------------------------------------
	// f
	//--------------------------------------------------------------------------
	/**
	 * f̎擾
	 * @return f
	 */
	virtual CharacterModel* getModel();

	/**
	 * U{[̎擾
	 * @return U{[
	 */
	virtual Bone* getAttackBone();

	/**
	 * ̃{[̎擾
	 * @return ̃{[
	 */
	virtual Bone* getBodyBone();

	//--------------------------------------------------------------------------
	// Aj[V
	//--------------------------------------------------------------------------
	/**
	 * Aj[V̎擾
	 * @return Aj[V
	 */
	virtual Animation* getAnimation();

	//--------------------------------------------------------------------------
	// RW
	//--------------------------------------------------------------------------
	/**
	 * RWm[h̎擾
	 * @return RWm[h
	 */
	virtual CollisionNode* getCollisionNode();

	/**
	 * n`RW̎擾
	 * @return n`RW
	 */
	virtual StaticSphereCollision* getLandCollision();

	/**
	 * _[WRW̎擾
	 * @return _[WRW
	 */
	virtual StaticSphereCollision* getDamageCollision();

	/**
	 * URW̎擾
	 * @return URW
	 */
	virtual StaticSphereCollision* getAttackCollision();

	//--------------------------------------------------------------------------
	// ʒu
	//--------------------------------------------------------------------------
	/**
	 * ʒu̐ݒ
	 * @param position ʒu
	 */
	virtual void setPosition(const Vector3& position);

	/**
	 * ʒu̎擾
	 * @return ʒu
	 */
	virtual const Vector3& getPosition() const;

	//--------------------------------------------------------------------------
	// ]
	//--------------------------------------------------------------------------
	/**
	 * ̐ݒ
	 * @param direction 
	 */
	virtual void setDirection(const Vector3& direction);

	/**
	 * ̎擾
	 * @return 
	 */
	virtual const Vector3& getDirection() const;

	/**
	 * ]̎擾
	 * @return ]
	 */
	virtual const Vector3& getRotation() const;

	//--------------------------------------------------------------------------
	// x
	//--------------------------------------------------------------------------
	/**
	 * x̐ݒ
	 * @param velocity x
	 */
	virtual void setVelocity(const Vector3& velocity);

	/**
	 * x̎擾
	 * @return x
	 */
	virtual const Vector3& getVelocity() const;

	//--------------------------------------------------------------------------
	// 󒆃tO
	//--------------------------------------------------------------------------
	/**
	 * 󒆃tO̐ݒ
	 * @param isAerial 󒆂Ȃtrue
	 */
	virtual void setAerial(bool isAerial);

	/**
	 * 󒆃tO̎擾
	 * @return 󒆂Ȃtrue
	 */
	virtual bool isAerial() const;

	//--------------------------------------------------------------------------
	// Ct
	//--------------------------------------------------------------------------
	/**
	 * ̐ݒ
	 * @param life 
	 */
	virtual void setLife(int life);

	/**
	 * ̎擾
	 * @return 
	 */
	virtual int getLife() const;

	/**
	 * ̗͂̐ݒ
	 * @param health ̗
	 */
	virtual void setHealth(int health);

	/**
	 * ̗͂̎擾
	 * @return ̗
	 */
	virtual int getHealth() const;

	/**
	 * ł邩
	 * @return łȂtrue
	 */
	virtual bool isDeath() const;

	/**
	 * SłĂ邩
	 * @return SłĂtrue
	 */
	virtual bool isAnnihilated() const;

	//--------------------------------------------------------------------------
	// _[W
	//--------------------------------------------------------------------------
	/**
	 * _[W̎擾
	 * @return _[W
	 */
	virtual const Vector3& getDamageDirection() const;

	/**
	 * _[Wl̎擾
	 * @return _[Wl
	 */
	virtual int getDamageValue() const;

	/**
	 * _[W̃NA
	 */
	virtual void clearDamage();

	/**
	 * GJE^̎擾
	 * @return GJE^
	 */
	virtual int getMatchlessCounter() const;

	/**
	 * GJE^̐ݒ
	 * @param matchlessCounter GJE^
	 */
	virtual void setMatchlessCounter(int matchlessCounter);

	//--------------------------------------------------------------------------
	/**
	 * _̎擾
	 * @return _
	 */
	virtual Random& getRandom();

private:
	//--------------------------------------------------------------------------
	// Rs[RXgN^̉B
	EnemyState(const EnemyState& copy);

	// Rs[̉B
	void operator =(const EnemyState& copy);

	//--------------------------------------------------------------------------
	// G
	Enemy* enemy_;
	// sJE^
	int runCounter_;
	// vCƂ̊Ԋu
	Vector3 playerDistance_;

};

//------------------------------------------------------------------------------
#endif // End of ENEMY_STATE_H_
//------------------------------------------------------------------------------

