//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ZOgeXg
 * @author Junpee
 */

#include "Test/stdafx.h"
#include "Geometry/Distance/SegmentDistanceTest.h"

//------------------------------------------------------------------------------
// RXgN^
SegmentDistanceTest::SegmentDistanceTest(String name) :
	TestCase(name){
}
//------------------------------------------------------------------------------
// eXgXB[g̎擾
Test* SegmentDistanceTest::suite(){
	TestSuite* suite = new TestSuite("SegmentDistanceTest");
	suite->addTest(new TestCaller(SegmentDistanceTest, testPoint));
	suite->addTest(new TestCaller(SegmentDistanceTest, testSegment));
	suite->addTest(new TestCaller(SegmentDistanceTest, testSphere));
	suite->addTest(new TestCaller(SegmentDistanceTest, testTriangle));
	return suite;
}
//------------------------------------------------------------------------------
// _eXg
void SegmentDistanceTest::testPoint(){
}
//------------------------------------------------------------------------------
// ZOgeXg
void SegmentDistanceTest::testSegment(){
	Segment segment0(0.f, 0.f, 0.f, 0.f, 1.f, 0.f);
	TestEquals(1.f, segment0.getDistance(Vector3(0.f, 2.f, 0.f)));
	TestEquals(1.f, segment0.getDistance(Vector3(0.f, -1.f, 0.f)));
	TestEquals(1.f, segment0.getDistance(Vector3(1.f, 0.f, 0.f)));
	Segment segment1(0.f, 2.f, 0.f, 0.f, 1.f, 0.f);
	TestEquals(1.f, segment0.getDistance(segment1));
	segment1.setOrigin(Vector3(1.f, 0.f, 0.f));
	TestEquals(1.f, segment0.getDistance(segment1));
	segment1.setDirection(Vector3(1.f, 0.f, 0.f));
	TestEquals(1.f, segment0.getDistance(segment1));
	segment1.setOrigin(Vector3(-1.f, 0.f, 0.f));
	TestEquals(0.f, segment0.getDistance(segment1));
}
//------------------------------------------------------------------------------
// eXg
void SegmentDistanceTest::testSphere(){
}
//------------------------------------------------------------------------------
// OpeXg
void SegmentDistanceTest::testTriangle(){
}
//------------------------------------------------------------------------------
